C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c hp BEMP03
c Ausgabe-Files (Plotfiles) aus BEM-Ergebnisfile
c
c BEM-Ergebnisse ueber unit 56
c Steueranweisungen ueber unit "idef"
c    1 ... N) Variablen-Definitionen (N<=20)
c
c Ausgabe-Files: 60 (daten)
c                61 (texte)
c --------------------------------------------------
      subroutine bemp03(idef,iwrite,ierbem,jmp)
      include 'inc001'
      parameter (mvar=20,mtim=25)
      include 'inc002'
      character rec*80,tl*24,varlbl*24,upperc*80,bemvrs*4
      dimension tl(30),varlbl(mvar)
      integer ktyp(5,mvar), nvar/0/,ktim(mtim),trmlen
      double precision x0(mx),ctlc(mcat),ctla(mani)
      real xout(mvar)
      data ntim/0/


      if (jmp.eq.0) then ! 30.12.93
         jump=1
      else
         jump=jmp
      endif

      nvar=0
      ntim=0
c
100   format(a)
101   format(1x,a)

      call uopen(60,'data',' ')
      call uopen(61,'text',' ')
      ires=56
     
      call uopen(ires,'res','.r')
c
c
         read(ires,100) rec
         if(iwrite.gt.0) write(iwrite,103) bemvrs()
 103     format('BEM(',a4,'): output of selected results')
         call mess(401,rec,r,i)
         write(61,100) rec(1:trmlen(rec))
         lvar=-1                           ! 16.6.94
         call inpar(ires,0,6,lvar,ierbem)
         if(ierbem.ne.0) return
         call start(ires,0,1,ierbem)
         if(ierbem.ne.0) return
c
c Versuche (Zeiten) auswaehlen
c
      read(idef,100) rec
      if (upperc(rec(1:3)).ne.'TIM') stop 'TIM-Anweisung fehlt'
      write(61,100) rec(1:trmlen(rec))
      call wktlst(rec,tl,ntl)
      if (ntl.lt.2) goto 259
      if (tl(2).eq.'*') go to 259
      ntim=ntl-1
      if (ntim.gt.mtim) stop 'Zu viele Zeiten spezifiziert'
      do 251 L=2,ntl
251   read(tl(L),*) ktim(L-1)
259   continue
c
c Lesen der Variablen-Definitionen
c
200   read(idef,100,end=300) rec
      if (rec.eq.' ') goto 200   ! neu 20.11.92
      nvar=nvar+1
      if(nvar.gt.mvar) go to 901
      call ppvar(rec,ktyp(1,nvar),varlbl(nvar),ier)
      if(ier.ne.0) then
           ierbem=ier
           return
      endif
c     write(61,100) rec(1:trmlen(rec))
      write(61,100) varlbl(nvar)
      goto 200
c
c Lesen und Schreiben der Daten
c
300   lout=1
310   call ppread(kstep,ltit,exch,ires,0,0,ierbem)
      if(ierbem.ne.0) return
      if (kstep.eq.-1) goto 311
309   continue

      k=0
      if(ntim.gt.0) k=ktim(lout) 
      if(ltit.eq.k.or.ntim.eq.0.and.
     &                      mod(ltit,jump).eq.0) then
         call ctl(ctlc,ctla)
         vol=-999.
         do 301 l=1,nvar
301      call ppvcpt(ktyp(1,L),xout(L),ctlc,ctla,ltit,vol)
         write(60,102) (xout(LL),ll=1,nvar)
102      format(20(1x,g11.5))
         lout=lout+1
         if(lout.gt.ntim.and.ntim.gt.0) goto 311
         goto 320
      else if (ltit.gt.ktim(lout)) then
         lout=lout+1
         if(lout.gt.ntim.and.ntim.gt.0) goto 311
         goto 309
      else
         goto 320
      endif
311   continue
      close (unit=ires)
      close (unit=60)
      close (unit=61)
      return

c Flickwerk (leider), Aenderung 14.2.93
 320  call dctin
      goto 310


901   if(iwrite.gt.0) write(iwrite,9010)  rec
      ierbem=55
      return
9010  format('0***** Zu viele Variable definiert:',a)
      end
