C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c hp bemp04
c postprocessor zu bem, verarbeitet das Ergebnis-File
c vollstaendige Darstellung auf dem Drucker in EinzelGleichgewichten
c
      subroutine bemp04(ierbem)
      include 'inc001'
      include 'inc002'

      character rec*80,varlbl*12,bemvrs*4
      dimension ctla(mani),ctlc(mcat),ktim(100),varlbl(20)
c
ccc      zeit=tstamp()
      write(6,107) bemvrs()   !!! ,zeit
107   format(' BEMP04 (',a,'): ',a)
c ....................................... neu 9.3.92
      read(5,100) rec
100   format(a)
      read(rec,*) ntim                      !  "
      read(5,100) rec
      read(rec,*) (ktim(ll),ll=1,ntim)     !  "
      irfile=56
      open (unit=56,status='old')
      open (unit=61,file='LISTE')
      write(61,111) zeit
111   format(////' Ausgabe durch BEMP04: ',a)
c
c Lesen der Kopfdaten des Ergebnis-Files
c
300   continue
         read(irfile,'(a)')rec
         write(61,105) rec
         write(6,105) rec
105      format(' Ergebnis-File stammt von: ',a)
         write(61,106)
106      format(////
     2,' MODELL - File'/
     3,' ============='//)
         lvar=-1   ! 16.6.94
         call inpar(irfile,0,61,lvar,ierbem)
         if(ierbem.ne.0) return
         call start(irfile,0,1,ierbem)
         if(ierbem.ne.0) return
         
         call partab(61)
         call statab(61)
      ncas=0
      ltim=1
400   continue
      call ppread(kstep,ltit,exch,irfile,61,0,ierbem)
      if(ierbem.ne.0) return
      if (kstep.eq.-1) goto 800
      if(ntim.eq.0.or.ltit.eq.ktim(ltim)) then
         ncas=ncas+1
         write(61,110) ltit
110      format('0Gleichgewicht Nr. ',i4,':')
         call tabcas(61)
         if(ntim.ne.0) then
            ltim=ltim+1
            if(ltim.gt.ntim) goto 800
         endif
      endif
         go to 400
c
800   stop
      end
