C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c Interpretation von {  ,  ,  , ... } fuer BEM RUNVAR
c Aufruf: rec1 = string Eingabe
c         rec2 = Ausgabe-String
c         i = index, der angibt, welche Variante ausgegeben werden soll
c             (Eingabe)
c         n = Gesamtzahl der durch den Eingabstring geforderten
c             Varianten, Ausgabe, n=-1 bei error
c             (Ausgabe)
c
      subroutine brcint(rec1,rec2,i,n)
      character rec1*(*),rec2*(*),del2*1
      data del2/' '/   !  items in braces delimited by del2

      k1=index(rec1,'{')
      k2=index(rec1,'}')
      if(i.lt.0.or.k1.eq.0.or.k2.eq.0.or.k2-k1.lt.2) then
         n=-1
         rec2=rec1
         return
      endif
c

      l=1
      k=len(rec1)
c
      kout=k2+1
      if(del2.eq.' ') then
         do ldo=k2-1,k1+1,-1
            kk=ldo
            if(rec1(ldo:ldo).ne.' ') goto 202
         end do
 202     continue
         k2=kk+1
      endif

      k6=k1
      do ldo=1,k
 201     k3=index(rec1(k6+1:k2-1),del2)
         if(k3.eq.1.and.del2.eq.' ') then !  several blanks = 1 delimiter
            k6=k6+1
            go to 201
         endif
         k5=k3+k6
         if(k3.gt.0) then
            k4=k5
         else
            k4=k2
         endif
         if(i.eq.l) then
            if(1.le.k1-1) then
               rec2=rec1(1:k1-1)//rec1(k6+1:k4-1)
               k7=k1-1   +   k4-k6-1
            else
               rec2=rec1(k6+1:k4-1)
               k7=k4-k6-1
            endif
            if(kout.le.k) rec2=rec2(1:k7)//rec1(kout:k)
         endif
         if(k3.gt.0) then
            k6=k5
            l=l+1
         else
            n=l
            if(i.le.0) rec2=rec1
            return
         endif
      end do
      end
c
c
c
c$$$      program test
c$$$      character rec1*40,rec2*40
c$$$200   read(5,100,end=800) rec1
c$$$100   format(a)
c$$$      ii=0
c$$$      call brcint(rec1,rec2,ii,n)
c$$$      print *,n
c$$$      do l=0,n+2
c$$$         call brcint(rec1,rec2,l,nn)
c$$$         print *,l,'>'//rec2//'<'
c$$$      end do
c$$$      goto 200
c$$$800   stop
c$$$      end
