C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
      subroutine contrl(eps,ier)
      include 'inc001'
      include 'inc002'
      dimension xctcat(mcat),xctani(mani)

      do 201 l=0,mz
201   gam(l)=10.d0**
     2 (-0.5d0*(l*l)*(dsqrt(str)/(1.d0+dsqrt(str))-0.3d0*str))
      ier=0
c .....................................................
      xe=0.d0
      xi=0.d0
      do 202 l=1,ncat
      xe=xe+ccat(l)*izcat(l)
202   xi=xi+ccat(l)*izcat(l)**2 *.5d0
      do 203 l=1,nani
      xe=xe-cani(l)*izani(l)
203   xi=xi+cani(l)*izani(l)**2 *.5d0
      do 204 l=1,ncpl
      xe=xe+ccpl(l)*izcpl(l)
204   xi=xi+ccpl(l)*izcpl(l)**2 *.5d0
C     call ctrtst(*800,ier,100,eps,xe/xi)           @ ENB
      call ctrtst(*800,ier,100,eps,xe/xi)
C     call ctrtst(*800,ier,200,eps,(xi-str)/str)  @ I
      call ctrtst(*800,ier,200,eps,(xi-str)/str)
c ....................................... Element-Bilanzen
      do 301 l=2,ncat
      xctcat(l)=ccat(l)
      if (nake.gt.0) then
         xctcat(l)=xctcat(l) + xs(l)*ake/izcat(l)
      endif
301   continue
      do 302 l=2,nani
302   xctani(l)=cani(l)
      do 303 l1=1,ncpl
      do 304 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      if(k.eq.0) then
         go to 303
      else if (k.eq.1) then
         go to 304
      else if (k.eq.-1) then
         go to 304
      else if (k.gt.1) then
         xctcat(k)=xctcat(k)+ccpl(l1)*idfcpl(l2*2,l1)
      else
         xctani(-k)=xctani(-k)+ccpl(l1)*idfcpl(l2*2,l1)
      endif
304   continue
303   continue
      do 308 l1=1,nslt
      do 309 l2=1,mptslt
      k=idfslt(l2*2-1,l1)
      if(k.eq.0) then
         go to 308
      else if (k.eq.1) then
         go to 309
      else if (k.eq.-1) then
         go to 309
      else if (k.gt.1) then
         xctcat(k)=xctcat(k)+cslt(l1)*idfslt(l2*2,l1)
      else
         xctani(-k)=xctani(-k)+cslt(l1)*idfslt(l2*2,l1)
      endif
309   continue
308   continue
310   continue
      do 306 l=2,ncat
306   call ctrtst(*800,ier,300+l,eps,(ctcat(l)-xctcat(l))/ctcat(l))
      if(ico2.gt.0) xctani(ico2)=ccpl(ih2co3)*10.d0**pkco2(1)
      do 307 l=2,nani
307   call ctrtst(*800,ier,400+l,eps,(ctani(l)-xctani(l))/ctani(l))
c ..................................... Komplex-Gleichgewichte
      do 401 l1=1,ncpl
      if (ccpl(l1).lt.1.d-70) goto 401
      pkx=+dlog10(ccpl(l1)*gam(iabs(izcpl(l1))))
      do 402 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      if(k.eq.0) then
         go to 403
      else if(k.gt.0) then
         pkx=pkx-dlog10(ccat(k)*gam(izcat(k)))*idfcpl(l2*2,l1)
      else
         pkx=pkx-dlog10(cani(-k)*gam(izani(-k)))*idfcpl(l2*2,l1)
      endif
402   continue
403   continue
      call ctrtst(*800,ier,500+l1,eps,(pkx-pkcpl(l1)))
401   continue
c ................................Kationenaustausch..........
      if(kex.eq.0) go to 599
      s=0.d0
      do 501 l=1,ncat
      s=s+xs(l)
501   continue
      call ctrtst(*800,ier,600,eps,s-1.d0)
      do 502 l=2,ncat
      if (exform.eq.'GAP') then
           frm=1.d0
      else if (exform.eq.'SEL') then
           frm=izcat(l)
      endif
      pkx=-dlog10(ccat(l)*gam(izcat(l)))/izcat(l)+dlog10(ccat(1)*gam(1))
     2 - dlog10(xs(1)) + dlog10(xs(l))/frm
      call ctrtst(*800,ier,700+l,eps,(pkx-pkgap(l)))
502   continue
599   continue
c ......................... L:oslichkeitsprodukte
      if(nslt.eq.0) go to 699
      do 601 l1=1,nslt
      if(iswslt(l1).le.0) go to 601
      xpk=0.
      do 602 l2=1,mptslt
      k=idfslt(l2*2-1,l1)
      ff=idfslt(l2*2  ,l1)
      if(k.eq.0) go to 603
      if(k.gt.0) xpk=xpk+ff*(-dlog10(ccat(k)*gam(izcat(k))))
      if(k.lt.0) xpk=xpk+ff*(-dlog10(cani(-k)*gam(izani(-k))))
602   continue
603   continue
      if(int(pkslt(l1)).eq.10000) then
         call sfc1(pkl,dpkl,l1)
         pk=pkl
      else if(int(pkslt(l1)).eq.20000) then
         call sfc2(pkl,dpkl,l1)
         pk=pkl
      else if(int(pkslt(l1)).eq.30000) then
         call sfc4(pkl,dpkl,l1)
         pk=pkl
      else if(int(pkslt(l1)).eq.40000) then
         call sfc5(pkl,dpkl,l1)
         pk=pkl
      else
         pk=pkslt(l1)
      endif
      call ctrtst(*800,ier,800+l1,eps,(xpk-pk))
601   continue
699   continue
c
c
c
800   continue
ccc   if(ier.eq.303) print *,'CONTRL: ', xctcat(l),ctcat(l)
      return
      end
c
c
c
      subroutine ctrtst(*,ier,ii,e,t)
      double precision e,t
      if (dabs(t).le.e) return
      ier=ii
      return 1
      end
