C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
C SR hxdhdx
C MIT PROTOKOLL DER ITERATION (JEDER 10TE AUFRUF)
C GLEICHUNGSSYSTEM FUER GEKOPPELTE CHEMISCHE GLEICHGEWICHTE
C BERECHNET WIRD DIE QUADRATSUMME H DER ABWEICHUNGEN F VOM NULLVEKTOR
C      UND DER GRADIENT DH VON H
C
      SUBROUTINE hxdhdx (nx,x,H,DH,*)
      include 'inc001'
      include 'inc002'
      include 'inc004'
      common /errcom/ nerr
      DIMENSION X(mx), DF(mx,mx),FX(mx),DH(mx)
      DATA NCALL /0/,ifrist/0/,ncltot/0/,isig/1/

      NCALL=NCALL+1
      ncltot=ncltot+1
c
c     wenn's kein Ende findet: etwas dran klopfen
      if (mod(ncall,1000).eq.0) then
         do  l=1,nx
            scl(l)=scl(l)+scl(l)*1.5d0*mod(l,2)
ccc            isig=isig*(-1)
ccc            scl(l)=scl(l)+isig*scl(l)*0.5d0 ! 5.1.94
         end do
      endif
c
c
      call fxdfdx(x,nx,fx,df,*800)
      H=0.
      DO 302 L=1,NX
      H=H+FX(L)*FX(L)*scl(l)*scl(l)
      DH(L)=0.
      DO 302 L2=1,NX
302   DH(L)=DH(L)+2.*FX(L2)*DF(L2,L)*scl(l2)*scl(l2)
      if(ncall.gt.2200) print *,'HXDHDX ',ncall,h !!!!!!!!!!!!!!
c-------------------------------------------------------
      if (ncall.eq.1.or.mod(ncall,10).eq.0) then
         if (kls.ge.32) then
              WRITE(itrace,102) (X(LW),LW=1,NX)
              WRITE(itrace,102)(FX(LW),LW=1,NX)
              WRITE(itrace,102)(DH(LW),LW=1,NX)
         endif
         if (kls.ge.16) then
              write(itrace,101) ncall,h
         endif
101        FORMAT(' T16: ',I4,1X,g12.6)
102        FORMAT(' T32: ',5X,11(G10.4,1X))
      endif
c-------------------------------------------------------------
 800  if(nerr.gt.0) return 1

      RETURN
c---------------------------------------------------------
      ENTRY hwlast(nlast)
      nlast=ncall
         if (kls.ge.32) then
              WRITE(itrace,102) (X(LW),LW=1,NX)
              WRITE(itrace,102)(FX(LW),LW=1,NX)
              WRITE(itrace,102)(DH(LW),LW=1,NX)
         endif
         if (kls.ge.16) then
              write(itrace,101) ncall,h
         endif
500   NCALL=0
      RETURN

      end
