C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr inpar
c liest Modelldefinition ein
C
      SUBROUTINE inpar(imod,irfile,ilist,lvar,ierbem)
      parameter (mkenn=11)
      INCLUDE 'inc001'
      INCLUDE 'inc002'
      INCLUDE 'inc007'
      integer trmlen
      CHARACTER REC*80,TL*24,KENN*3,upperc*24,var*8
     b,typ*3,inp*80,cmtlbl*80
      dimension tl(30),kenn(mkenn)
      common /scrcom/ tl,inp
      data kenn/'CAT','ANI','CPL','END','CEC','CO2','SLT','RUN'
     b,'PKW','P01','P02'/

      pkw=14.d0
C
      ncat=1
      nani=1
      lblcat(1)='H'
      lblani(1)='OH'
      izcat(1)=1
      izani(1)=1
      ncpl=0
      nake=0
      kani=0
      ki=0
      kex=0
      ico2=0
      ih2co3=0
      kco2=0
      nslt=0
      kslt=0

      do 201 l1=1,mdfcpl
      do 201 l2=1,mcpl
201   idfcpl(l1,l2)=0
      do 204 l1=1,mdfslt
      do 204 l2=1,mslt
204   idfslt(l1,l2)=0
200   CONTINUE
203   READ(imod,100) inp
      if(inp.eq.' ') go to 203
      call brcint(inp,rec,lvar,n)
      if(irfile.gt.0) write(irfile,100) REC
      if(n.gt.0.and.irfile.gt.0) write(irfile,100) cmtlbl(inp)
      if(ilist.ne.0.and.ilist.ne.6) write(ilist,101) REC
      if(rec(1:1).eq.'*') goto 203
      CALL WKTLST(REC,TL,NTL)
      tl(1)=upperc(tl(1))
      do 202 l=1,mkenn
      if(kenn(l).eq.tl(1)) go to (300,400,500,600,700,800,
     b900,1000,1100,1200,1300),l
202   continue
      if(tl(1)(1:1).eq.'*') goto 200
      call mess(210,rec,r,i)
      ierbem=210
      goto 200
C
300   CONTINUE


c Definition von Kationen
      do 301 l=1,ncat
301   if(tl(2).eq.lblcat(l)) go to 9003
      ncat=ncat+1
      if (ncat.gt.mcat) then
         call mess(205,'cations',r,mcat)
         ierbem=205
      endif
      lblcat(ncat)=tl(2)
      read(tl(3),*,err=9002) izcat(ncat)
      GO TO 200
400   CONTINUE
c Definition von Anionen
      do 402 l=1,nani
402   if(tl(2).eq.lblani(l)) go to 9003
      nani=nani+1
401   if (nani.gt.mani) then
         call mess(205,'anions',r,mani)
         ierbem=205
      else
         lblani(nani)=tl(2)
         read(tl(3),*,err=9002) izani(nani)
      endif
      GO TO 200
500   CONTINUE
c Definition von Komplexen
      do 503 l=1,ncpl
503   if(tl(2).eq.lblcpl(l)) go to 9003
      ncpl=ncpl+1
501   if(ncpl.gt.mcpl) then
         call mess(205,'complexes',r,mcpl)
         ierbem=205
      else
         lblcpl(ncpl)=tl(2)
         call defi (tl(2),idfcpl,lblani,lblcat,mdfcpl,ncpl,nani,ncat
     &        ,ierbem)
         izcpl(ncpl)=0
         do 502 l=1,mptcpl
            k=idfcpl(l*2-1,ncpl)
            if(k.eq.0) go to 502
            if(k.gt.0) then
               izcpl(ncpl)=izcpl(ncpl)+izcat( k)*idfcpl(l*2,ncpl)
            else
               izcpl(ncpl)=izcpl(ncpl)-izani(-k)*idfcpl(l*2,ncpl)
            endif
 502     continue
         read (tl(3),*,err=9002) pkcpl(ncpl)
      endif
      go to 200

600   CONTINUE
      kani=ncaT+1
      ki=ncat+nani
      if(nake.gt.0) kex=ki+1
      if(nslt.gt.0) kslt=ki+nake+1
      ff=-dlog(10.d0)
      eqw=pkw*ff
      do 601 l=1,ncpl
601   eqcpl(l)=pkcpl(l)*ff
      kco2=kani-1+ico2
      if(nslt.gt.0) then
           do 603 l=1,nslt
           pk=pkslt(l)
           if(int(pk).eq.-100) then
ccc           if(npar1.lt.3) goto 9006
              pk=par1a+par1c
           endif
           eqslt(l)=pk*ff
603        continue
      endif
      nca=ncat
      nan=nani
      nak=nake
      nsl=nslt
      nx=ncat+nani+nake+nslt
c
      RETURN
700   continue
c Angabe von AKe
      nake=1
      do 701 L=2,ntl
         if (upperc(tl(L)(1:3)).eq.'TYP') then
            if(upperc(tl(L)(5:7)).eq.'SEL') then
               exform='SEL'
            else if(upperc(tl(L)(5:7)).eq.'GAP') then
               exform='GAP'
            else
               call mess(211,tl(l),r,i)
               ierbem=211
            endif
         else
            call varval(tl(L),var,val,0,ierbem)
ccc            if(ierbem.ne.0) return
            do 702 L2=1,ncat
               if (var.eq.lblcat(L2)) then
                  pkgap(L2)=val
                  eqex(L2)=val*(-dlog(10.d0))
                  goto 701
               endif
 702        continue
            call mess(208, tl(L),r,i)
            ierbem=208
         endif
 701  continue
      goto 200
c
800   continue
c Vorsehen eines festen CO2-Partialdrucks
      if(ico2.gt.0) go to 9003
      do 801 l=1,3
801   read (tl(l+1),*,err=9002) pkco2(l)
      nani=nani+1
      ncpl=ncpl+2
      if(nani.gt.mani) then
         call mess(205,'anions',r,mani)
         ierbem=205
      else if(ncpl.gt.mcpl) then
         call mess(205,'complexes',r,mcpl)
         ierbem=205
      else
         lblani(nani)='CO3'
         izani(nani)=2
         lblcpl(ncpl-1)='(H)(CO3)'
         lblcpl(ncpl)='(H)2(CO3)'
         pkcpl(ncpl-1)=pkco2(3)
         pkcpl(ncpl)=pkco2(2)+pkco2(3)
         idfcpl(1,ncpl-1)=1
         idfcpl(2,ncpl-1)=1
         idfcpl(3,ncpl-1)=-nani
         idfcpl(4,ncpl-1)=1
         idfcpl(5,ncpl-1)=0
         izcpl(ncpl-1)=-1
         idfcpl(1,ncpl  )=1
         idfcpl(2,ncpl  )=2
         idfcpl(3,ncpl  )=-nani
         idfcpl(4,ncpl  )=1
         idfcpl(5,ncpl  )=0
         izcpl(ncpl  )=0
         ico2=nani
         ih2co3=ncpl
      endif
      go to 200
c
900   CONTINUE
c Salz-Definitionen
      do 903 l=1,nslt
903   if(tl(2).eq.lblslt(l)) go to 9003
      nslt=nslt+1
901   if(nslt.gt.mslt) then
         call mess(205,'salts',r,mslt)
         ierbem=205
      else
         lblslt(nslt)=tl(2)
         call defi (tl(2),idfslt,lblani,lblcat,mdfslt,nslt,nani,ncat
     &        ,ierbem)
         iz=0
         do 902 l=1,mptslt
            k=idfslt(l*2-1,nslt)
            if(k.eq.0) go to 902
            if(k.gt.0) then
               iz=iz+izcat( k)*idfslt(l*2,nslt)
            else
               iz=iz-izani(-k)*idfslt(l*2,nslt)
            endif
 902     continue
         if(iz.ne.0) then
            ierbem=206
            call mess(ierbem,tl(2),r,i)
         endif
         if(upperc(tl(3)).eq.'SFC1') then
            pkslt(nslt)=10000
         else if(upperc(tl(3)).eq.'SFC2') then
            pkslt(nslt)=20000
         else if(upperc(tl(3)).eq.'SFC4') then
            pkslt(nslt)=30000
         else if(upperc(tl(3)).eq.'SFC5') then
            pkslt(nslt)=40000
         else
            read (tl(3),*,err=9002) pkslt(nslt)
         endif
      endif
      GO TO 200
c
c RUN - Steuerzeile
c
1000  continue

      call runset(rec,ierbem)

      goto 200
c PKW-Angabe
1100  continue
      if (ntl.lt.2) goto 9002
      read(tl(2),*,err=9002) pkw
      goto 200
c PAR1 ...................... Parameter-Satz 1
1200  continue
      if (ntl.lt.4) goto 9002
      read(tl(2),*,err=9002) par1a
      read(tl(3),*,err=9002) par1b
      read(tl(4),*,err=9002) par1c
ccc   npar1=3
      goto 200
c P02 ...................... Parameter-Satz 2
1300  continue
      if (ntl.lt.7) goto 9004
      read(tl(2),*,err=9002) x1
      read(tl(3),*,err=9002) y1
      read(tl(4),*,err=9002) d1
      read(tl(5),*,err=9002) x2
      read(tl(6),*,err=9002) y2
      read(tl(7),*,err=9002) d2
      call setspl(x1,x2,y1,y2,d1,d2)
      goto 200
c
c   Fehler-Bearbeitung
c
c
 9002 call mess(202,rec,r,i) 
      ierbem=202
      return

 9003 call mess(209,tl(2),r,i)
      ierbem=209
      return

 9004 call mess(243,rec,r,7)
      ierbem=243
      return

100   FORMAT (A80)
101   FORMAT (1x,A80)
102   FORMAT ()
      END

