C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr ppvar
c Variablen-Definitionen zum pp-File von bcm1
c .
      subroutine ppvar(rec,ktyp,lbl,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      integer ktyp(5),trmlen
      character rec*80,tl*24,lbl*(*),upperc*24
      real val
      dimension ctlc(mcat),ctla(mani),tl(8)
     &,ctsc(mcat),ctsa(mani)
c
ccc      ierbem=0
      call wktlst(rec,tl,ntl)
ccc      if(ntl.le.0) go to 999
      if(ntl.le.0) then
         call mess(410,rec,r,i)
         ierbem=410
         return
      endif
      tl(1)=upperc(tl(1))
      do 201 l=1,5
201   ktyp(l)=0
      if(ntl.ge.1.and.tl(1).eq.'PH') then
           ktyp(1)=1
           klbl=1
      else if (ntl.ge.2.and.tl(1).eq.'CTL') then
           klbl=2
           do 202 l=1,ncat
           if(lblcat(l).eq.tl(2)) then
                if(l.eq.1) go to 903
                ktyp(1)=2
                ktyp(2)=l
                go to 300
           endif
202        continue
           do 203 l=1,nani
           if(lblani(l).eq.tl(2)) then
                if(l.eq.1) go to 903
                ktyp(1)=3
                ktyp(2)=l
                go to 300
           endif
203        continue
           go to 904
      else if (tl(1).eq.'SNG'.and.ntl.ge.2) then
           klbl=2
           do 204 l=1,ncat
           if(lblcat(l).eq.tl(2)) then
                ktyp(1)=4
                ktyp(2)=l
                go to 300
           endif
204        continue
           do 205 l=1,nani
           if(lblani(l).eq.tl(2)) then
                ktyp(1)=5
                ktyp(2)=l
                go to 300
           endif
205        continue
           go to 904
      else if(ntl.ge.2.and.tl(1).eq.'CPL') then
           do 206 l=1,ncpl
           if(tl(2).eq.lblcpl(l)) then
                ktyp(1)=6
                ktyp(2)=l
                klbl=2
                go to 300
           endif
206        continue
           go to 904
      else if (tl(1).eq.'CTT'.and.ntl.ge.2) then
           klbl=2
           do 207 l=1,ncat
           if(lblcat(l).eq.tl(2)) then
                ktyp(1)=7
                ktyp(2)=l
                go to 300
           endif
207        continue
           do 208 l=1,nani
           if(lblani(l).eq.tl(2)) then
                ktyp(1)=8
                ktyp(2)=l
                go to 300
           endif
208        continue
           go to 904
      else if(ntl.ge.1.and.tl(1).eq.'NUM') then
           ktyp(1)=9
           klbl=1
      else if(ntl.ge.2.and.tl(1).eq.'XS%') then
           klbl=2
           do 210 l=1,ncat
           if(lblcat(l).eq.tl(2)) then
                ktyp(1)=10
                ktyp(2)=l
                go to 300
           endif
210        continue
           go to 904
      else if(ntl.ge.2.and.tl(1).eq.'CEX') then
           klbl=2
           do 211 l=1,ncat
           if(lblcat(l).eq.tl(2)) then
                ktyp(1)=11
                ktyp(2)=l
                go to 300
           endif
211        continue
           go to 904
      else if(ntl.ge.2.and.tl(1).eq.'SLT') then
           klbl=2
           do 212 l=1,nslt
           if(lblslt(l).eq.tl(2)) then
                ktyp(1)=12
                ktyp(2)=l
                go to 300
           endif
212        continue
           go to 904
      else if (ntl.ge.1.and.tl(1).eq.'VOL') then
           klbl=1
           ktyp(1)=13
           go to 300
      else if (ntl.ge.2.and.tl(1).eq.'CIN') then
         klbl=2
           do 214 l=2,ncat
           k=l-1
           if(lblcat(l).eq.tl(2)) go to 2141
214        continue
           do 2142 l=2,nani
           k=ncat+l-2
           if(lblani(l).eq.tl(2)) goto 2141
2142       continue
           go to 904
2141       continue
           ktyp(1)=14
           ktyp(2)=k
           go to 300
      else if(ntl.ge.2.and.tl(1).eq.'SLT*') then
c SLT*: Salz in der Einheit mmol/kg
           klbl=2
           do 215 l=1,nslt
           if(lblslt(l).eq.tl(2)) then
                ktyp(1)=15
                ktyp(2)=l
                go to 300
           endif
215        continue
           go to 904
c Definition Nr. 16 = log(Konzentrationsverhaeltnis).......
c   (analytische Konz., mol/mol, bei H und OH Einzel-Ionen-Konz.)
      else if(ntl.ge.3.and.tl(1).eq.'LGCR') then
         ktyp(1)=16
         do l1=1,2
            do  l=1,ncat
               if(lblcat(l).eq.tl(l1+1)) then
                  ktyp(l1+1)=l
                  go to 2161
               endif
            end do
            do l=1,nani
               if(lblani(l).eq.tl(l1+1)) then
                  ktyp(l1+1)=-l
                  goto 2161
               endif
            end do
            goto 904
2161        continue
         end do
         if(ntl.eq.3) then
            lbl='log('//tl(2)(1:trmlen(tl(2)))//'/'
     &//tl(3)(1:trmlen(tl(3)))//')'
         else
            lbl=tl(4)
         endif
         return
c Definition Nr. 17/18 = Delta - Sorption in mmol/kg  ! falscher Kommentar
c Definition Nr. 17/18 = Delta - Sorption in mmol(eq)/kg ! JP 19.8.94
      else if (ntl.ge.2.and.tl(1).eq.'DCS') then
           klbl=2
           do  l=1,ncat
              if(lblcat(l).eq.tl(2)) then
                   if(l.eq.1) go to 903
                   ktyp(1)=17
                   ktyp(2)=l
                   go to 300
              endif
           end do
           do  l=1,nani
              if(lblani(l).eq.tl(2)) then
                   if(l.eq.1) go to 903
                   ktyp(1)=18
                   ktyp(2)=l
                   go to 300
              endif
           end do
           go to 904
c Definition Nr. 19:    MRK = Marke (fuer Subfiles)
      else if (ntl.ge.2.and.tl(1).eq.'MRK') then
           klbl=2
           ktyp(1)=19
           read(tl(2),*,err=903) ktyp(2)
c Definition Nr. 20: "TIME t0 dt" fuer Ausgabe von "steps" als Zeit 
        else if (ntl.ge.3.and.tl(1).eq.'TIME') then
           klbl=3
           ktyp(1)=20
           read(tl(2),*,err=903) tim0
           read(tl(3),*,err=903) dtim
c.............................................................
      else
           call mess(410,rec,r,i)
           ierbem=410
           return
      endif
c
c Setzen der Variablen-Label
c
300   continue
      if(ntl.eq.klbl) then
           if(klbl.eq.1.or.ktyp(1).eq.20) then
                lbl=tl(1)
           else
                lbl=tl(1)(1:trmlen(tl(1)))//'-'//tl(klbl)
           endif
      else
           lbl=tl(klbl+1)
      endif
      return
c
c sr ppvcpt
c Berechnung der zuvor definierten Variablen
c
      entry ppvcpt(ktyp,val,ctlc,ctla,ltit,vol)
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
     b,18,19,20,21),ktyp(1)

      call mess(411,c,r,ktyp(1))
      ierbem=411
      return
1     continue
      val=-dlog10(ccat(1)*gam(1))
      return
2     continue
      val=ctlc(ktyp(2))*1.d6
      return
3     continue
      val=ctla(ktyp(2))*1.d6
      return
4     continue
      val=ccat(ktyp(2))*1.d6
      return
5     continue
      val=cani(ktyp(2))*1.d6
      return
6     continue
      val=ccpl(ktyp(2))*1.d6
      return
7     continue
      val=ctcat(ktyp(2))*1.d6
      return
8     continue
      val=ctani(ktyp(2))*1.d6
      return
9     continue
      val=ltit
      return
10    continue
      val=xs(ktyp(2))*100.d0
      return
11    continue
      val=xs(ktyp(2))*ake*1.d6/izcat(ktyp(2))
      return
12    continue
      val=cslt(ktyp(2))*1.d6
      return
13    continue
      val=vol
      return
14    continue
      val=ctin(ktyp(2),1)
      return
15    continue
      val=cslt(ktyp(2))*1.d3/ssr
      return
16    continue
      v1=0.d0
      v2=0.d0
      if(ktyp(2).eq.1) v1=ccat(1)
      if(ktyp(3).eq.1) v2=ccat(1)
      if(ktyp(2).eq.-1) v1=cani(1)
      if(ktyp(3).eq.-1) v2=cani(1)
      if(ktyp(2).gt.1) v1=ctlc(ktyp(2))
      if(ktyp(3).gt.1) v2=ctlc(ktyp(3))
      if(ktyp(2).lt.-1) v1=ctla(-ktyp(2))
      if(ktyp(3).lt.-1) v2=ctla(-ktyp(3))
      if(v2.gt.1.d-50) then
         val=dlog10(v1/v2)
      else
         val=999.d0
      endif
      return
17    continue
      if(ltit.eq.0) ctsc(ktyp(2))=ctcat(ktyp(2))-ctlc(ktyp(2))
      val=(ctcat(ktyp(2))-ctlc(ktyp(2))-ctsc(ktyp(2)))
      val=val*1.d3/ssr*izcat(ktyp(2))
      return
18    continue
      if(ltit.eq.0) ctsa(ktyp(2))=ctani(ktyp(2))-ctla(ktyp(2))
      val=(ctani(ktyp(2))-ctla(ktyp(2))-ctsa(ktyp(2)))
      val=val*1.d3/ssr*izani(ktyp(2))
      return
19    continue
      val=ktyp(2)
      return
20    continue
      val=tim0+ltit*dtim
      return
 21   continue

 903  call mess(410,rec,r,i)
      ierbem=410
      return

 904  goto 903

ccc900   write(6,9000) ktyp(1)
ccc9000  format(' ***** PPVAR/PPVCPT: Code unbekannt: ',i4)
ccc      stop
ccc902   write(6,9020) rec
ccc9020  format('0PPVAR:***** Unverst:andliche Anweisung: ',a)
ccc      go to 999
ccc903   write(6,9030) rec
ccc9030  format('0PPVAR:***** Unsinnige Anweisung: ',a)
ccc      go to 999
ccc904   write(6,9040)tl(1)(1:trmlen(tl(1))), tl(2)
ccc9040  format('0PPVAR:***** Nicht definiert: ',a,' - ',a)
ccc      go to 999
ccc999   ier=1
ccc      return
      end
