C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr STRSET (BM-System)
c interpretiert Steuerzeilen, in denen Startwerte gesetzt werden
c
      subroutine strset(rec,kextyp,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc005'
      character tl*24,rec*80,var*24,upperc*80
      dimension tl(30)
      common /scrcom/ tl
c
      tl(1)=' '
      call wktlst(rec,tl,ntl)
      if (upperc(tl(1)).eq.'VLS') then
      do 201 l=2,ntl
         call varval(tl(l),var,val,1,ierbem)
         if(ierbem.ne.0) return
         if (var.eq.'SSR') then
            ssr=val
         else if (var.eq.'CEC') then
            if (kextyp.eq.2) goto 903
            kextyp=1
            AK=val
         else if (var.eq.'PCO2') then
            pco2=val
         else if (var.eq.'ESTPH') then
            ESTPH=val
         else if (var.eq.'ESTSTR') then
            eststr=val
         else if (var.eq.'ESTXSH') then
            estxsh=val
         else
            call mess(212,rec,r,i)
            ierbem=212
         endif
201      continue
      else if (upperc(tl(1)).eq.'CTL0') then
      do 202 l=2,ntl
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 203 l2=2,ncat
         if (var.eq.lblcat(l2)) then
            ctl0(l2-1)=val
            goto 204
         endif
203      continue
         do 205 l2=2,nani
         if (var.eq.lblani(l2)) then
            ctl0(ncat+l2-2)=val
            go to 204
         endif
205      continue
         call mess(213,rec,r,i)
         ierbem=213
204      continue
202   continue
      else if (upperc(tl(1)).eq.'XS0') then
            if (kextyp.eq.2) goto 903
            kextyp=1
      do 206 l=2,ntl
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 207 l2=2,ncat
         if (var.eq.lblcat(l2)) then
            xs0(l2)=val
            goto 208
         endif
207      continue
         call mess(213,rec,r,i)
         ierbem=213
208      continue
206   continue
      else if (upperc(tl(1)).eq.'CEX') then
            if (kextyp.eq.1) goto 903
            kextyp=2
      do 226 l=2,ntl
         if(tl(l).eq.'*!') goto 226
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 227 l2=1,ncat
         if (var.eq.lblcat(l2)) then
            cex(l2)=val
            goto 228
         endif
227      continue
         call mess(213,rec,r,i)
         ierbem=213
228      continue
226   continue
      else if (upperc(tl(1)).eq.'CSLT0') then
      do 209 l=2,ntl
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 210 l2=1,nslt
         if (var.eq.lblslt(l2)) then
            cslt0(l2)=val
            goto 211
         endif
210      continue
         call mess(214,rec,r,i)
         ierbem=214
211      continue
209   continue
      else if (upperc(tl(1)).eq.'WPTSLT') then
      do 212 l=2,ntl
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 214 l2=1,nslt
         if (var.eq.lblslt(l2)) then
            wptslt(l2)=val
            iwpfix(l2)=1 !!! neu 8.8.91
            goto 213
         endif
214      continue
         call mess(214,rec,r,i)
         ierbem=214
213      continue
212   continue
      else if (upperc(tl(1)).eq.'ESTSLT') then
         do 219 l=2,ntl
            call varval(tl(l),var,val,0,ierbem)
            if(ierbem.ne.0) return
            do 220 l2=1,nslt
               if (var.eq.lblslt(l2)) then
                  estslt(l2)=val
                  goto 221
               endif
 220        continue
            call mess(214,rec,r,i)
            ierbem=214
 221        continue
 219     continue
      else if (upperc(tl(1)).eq.'ESTCON') then
      do 215 l=2,ntl
      call varval(tl(l),var,val,0,ierbem)
      if(ierbem.ne.0) return
         do 216 l2=2,ncat
         if (var.eq.lblcat(l2)) then
            estcon(l2-1)=val
            goto 218
         endif
216      continue
         do 217 l2=2,nani
         if (var.eq.lblani(l2)) then
            estcon(ncat+l2-2)=val
            go to 218
         endif
217      continue
         call mess(213,rec,r,i)
         ierbem=213
218      continue
215   continue
      else
      call mess(200,rec,r,i)
      ierbem=200
      endif
      return
c

 903  call mess(215,rec,r,i)
      ierbem=215
      return

      end

