C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr STRTST (BM)
c ueberprueft, ob die notwendigen Startwerte bereitgestellt wurden
c
      subroutine strtst(ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc005'
      character upperc*80
c
      kstop=0
      if (nake.gt.0.and.ak.le.0.d0) then
ccc         write(6,9010) 'CEC'
         call mess(218,'CEC',r,i)
         ierbem=218
      endif
      if (ico2.gt.0.and.pco2.le.0.d0) then
         call mess(218,'PCO2',r,i)
         ierbem=218
      endif
      if (estph.le.0.d0) then
         call mess(218,'ESTPH',r,i)
         ierbem=218
      endif
      if (eststr.le.0.d0) then
         call mess(218,'ESTSTR',r,i)
         ierbem=218
      endif
      if (nake.gt.0.and.estxsh.le.0.d0) then
         call mess(218,'ESTXSH',r,i)
         ierbem=218
      endif
c
      do 201 l1=2,ncat
      if (ctl0(l1-1).lt.0.d0) then
c         call mess(216,'CTL0('//lblcat(l1)//')',r,i)
c         ierbem=216
      endif
      if (nake.gt.0.and.xs0(l1).lt.0.d0) then
c         call mess(216,'XS0('//lblcat(l1)//')',r,i)
c         ierbem=216
      endif
      if (estcon(l1-1).le.0.d0) then
         call mess(218,'ESTCON('//lblcat(l1)//')',r,i)
         ierbem=218
      endif
201   continue
c
      do 202 l2=2,nani
      if ((.not.(ico2.gt.0.and.lblani(l2).eq.'CO3'))
     b.and.(ctl0(ncat+l2-2).lt.0.d0)) then
c         call mess(216,'CTL0('//lblani(l2)//')',r,i)
c         ierbem=216
      endif
      if (estcon(ncat+l2-2).le.0.d0) then
         call mess(218,'ESTCON('//lblani(l2)//')',r,i)
         ierbem=218
      endif
202   continue
c
      if (nslt.gt.0) then
         do 203 L=1,nslt
ccc         if (wptslt(L).lt.0.d0) then
ccc            write (6,9011) 'WPTSLT',lblslt(L)
ccc            kstop=1
ccc         endif
         if (estslt(L).lt.0.d0) then
         call mess(216,'ESTSLT('//lblslt(l)//')',r,i)
         ierbem=216
         endif
203      continue
      endif
c     
      return

      end
