C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr SWSALT  (switch salts)
c
      subroutine swsalt(k01,ier)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      dimension delta(mslt)
      do 201 l=1,nslt
201   delta(l)=0.d0
c
      if(k01.eq.0) go to 300
      go to 400
c
C00   continue @ ----------------------- "nullter Aufruf"
300   continue
      do 301 l=1,nslt
      offslt(l)=0.d0
      if(cslt(l).gt.0.d0) then
         iswslt(l)=1
         delta(l)=wptslt(l)-cslt(l)
      else
         iswslt(l)=0
         delta(l)=0.d0
      endif
301   continue
      return
c
C00   continue  @ -------------------------- normaler Aufruf
400   continue
      do 401 l1=1,nslt
      xpk=0.d0
      do 402 l2=1,mptslt
      k=idfslt(l2*2-1,l1)
      f=idfslt(l2*2  ,l1)
      if(k.eq.0) go to 403
      if(k.gt.0) then
         xpk=xpk-f*dlog10(ccat(k)*gam(izcat(k)))
      else
         xpk=xpk-f*dlog10(cani(-k)*gam(izani(-k)))
      endif
402   continue
403   continue
      if(iswslt(l1).gt.0) then
         if(offslt(l1)+cslt(l1).lt.0.d0) then
            iswslt(l1)=0
            ier=-6000-l1
            delta(l1)=offslt(l1)
            cslt(l1)=0.d0
         endif
      else
         psat=(pkslt(l1)-xpk)
         if(psat.gt.4.3407d-4) then ! entspricht 1 Promille Uebersaett.
            iswslt(l1)=1
            ier=6000+l1
            go to 404     ! neu 28. 8. 87
         endif
      endif
401   continue
404   continue
c
c Setzen von DELTA, wenn Salz vorhanden
c
      do 410 l1=1,nslt
      if(iswslt(l1).gt.0) then
         delta(l1)=wptslt(l1)-cslt(l1)
      endif
410   continue
      return
c
c
c Bei Zuruecksetzen im Homotopieverfahren (NXTPNT):
      entry sltrst
      do 520 L=1,nslt
520   delta(L)=0.d0
      return
c
c
c
      entry actoff
500   continue ! ------------------- Regulierung des OFF-Speichers
      do 510 l=1,mx
510   ctoff(l)=0.d0
      do 501 l1=1,nslt
      offslt(l1)=offslt(l1)-delta(l1)
      do 502 l2=1,mptslt
      k=idfslt(l2*2-1,l1)
      f=idfslt(l2*2  ,l1)
      if(k.eq.0) go to 503
      if(k.eq.1) go to 502
      if(k.eq.-1) go to 502
      if(k.eq.-ico2) go to 502
      if(k.gt.0) then
         ctoff(k-1)=ctoff(k-1)+   f*offslt(l1)
ccc      ctoff(k-1)=  f*offslt(l1)
      else
         ctoff(ncat-k-2)=ctoff(ncat-k-2)+  f*offslt(l1)
ccc      ctoff(ncat-k-2)=  f*offslt(l1)
      endif
502   continue
503   continue
501   continue
c ------------------------------------------------------
      return
      end
