C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr TAB0
c produces table with information that has been recalculated from the model
c file 
c
c BEM-Ergebnisse ueber unit 56
c
c Ausgabe-Files: 60 
c --------------------------------------------------
      subroutine tab0(iwrite,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      character bemvrs*4,rec*80,vers*40
      integer trmlen
c
100   format(a)

      ilist=60
      call uopen(60,'tab0',' ')
      ires=56
     
      call uopen(ires,'res','.r')
c
c
         read(ires,100) rec
         if(iwrite.gt.0) write(iwrite,103) bemvrs()
 103     format('BEM(',a4,'): output of start conditions')

      write(vers,107) bemvrs()
107   format('BEM(',a,'): TAB0 displaying conditions of')
      write(ilist,101) vers(1:trmlen(vers)),rec(1:trmlen(rec))
 101  format(a/a/)



         call mess(401,rec,r,i)
         lvar=-1
                           ! 16.6.94
         call inpar(ires,0,6,lvar,ierbem)
         if(ierbem.ne.0) return
         call start(ires,0,1,ierbem)
         if(ierbem.ne.0) return
c
c 
c
      write(ilist,110) exform
 110  format(' Cation  pK-',a3,'    xs-0 (%)')
      do  l=1,ncat
         write(ilist,112) lblcat(l),pkgap(l),xs0(l)*100
 112     format(1x,a8,t10,f8.4,t19,f8.4)
      end do
      write(ilist,111) ak
 111  format(/' CEC = ',g10.4,' mmol(c)/kg')

      close (unit=ires)
      close (unit=60)
      return


      end













