C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr TABCAS (ersetzt OUTCAS)
c schreibt Tabelle eines berechneten Gleichgewichts
c
      subroutine tabcas(ilist)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      real ctlc(mcat),ctla(mani)
      character zle*132
      integer trmlen
c
      do 201 l=1,ncat
201   ctlc(l)=ccat(l)*1.d6
      do 202 l=1,nani
202   ctla(l)=cani(l)*1.d6
      do 203 l1=1,ncpl
      do 204 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      f=idfcpl(l2*2  ,l1)*1.d6
      if(k.eq.0) go to 203
      if(k.gt.0) then
      ctlc(k)=ctlc(k) + (ccpl(l1)*f)
      else
         ctla(-k)=ctla(-k) + (ccpl(l1)*f)
      endif
204   continue
203   continue
c ........................................... :Uberschrift
      write(ilist,101) ('-',l=1,130)
101   format(/t18,'Gesamt-Konzentrationen (1)',t61,'Konz. (1)'
     2,t73,'an.Konz. (1)',t87,'aust.Kat.(1)',t104
     3,'x-s [%]',t124,'pa'/1x,130a1)
102   format(g12.6)
103   format(1x,a)
104   format('(= ',g12.6,' + ',g12.6,')')
c ........................................... Kationen
      do 301 l=1,ncat
      zle=' '
      zle(1:8)=lblcat(l)
      if(l.gt.1) then
         write(zle(11:22),102) sngl(ctcat(l)+ctoff(l-1))*1.e6
         if(ctoff(l-1).ne.0.d0) then
            write(zle(24:54),104) sngl(ctcat(l))*1.e6,sngl(ctoff(l-1))
     $      *1.e6
         endif
         write(zle(73:84),102) ctlc(L)
      endif
      write(zle(59:70),102) sngl(ccat(l))*1.e6
      write(zle(119:130),102) -alog10(sngl(ccat(l)*gam(izcat(l))))
      if(nake.gt.0) then
         write(zle(87:98),102)sngl(xs(l)*ake)*1.e6 / izcat(l)
         zle(100:100)='='
         write(zle(102:113),102)sngl(xs(l))*1.e2
      endif
      write(ilist,103) zle
301   continue
c ........................................... Anionen
      do 302 l=1,nani
      zle=' '
      zle(1:8)=lblani(l)
      if(l.gt.1) then
         if(l.eq.ico2) then
            write(zle(11:22),102) sngl(ctani(l))*1.e3
            zle(27:54)='mbar CO2-Partialdruck'
         else
            kan=ncat+l-2
            write(zle(11:22),102) sngl(ctani(l)+ctoff(kan))*1.e6
            if(ctoff(kan).ne.0.d0) then
               write(zle(24:54),104) sngl(ctani(l))*1.e6
     $         ,sngl(ctoff(kan))*1.e6
            endif
         endif
         write(zle(73:84),102) ctla(L)
      endif
      write(zle(59:70),102) sngl(cani(l))*1.e6
      write(zle(119:130),102) -alog10(sngl(cani(l)*gam(izani(l))))
      write(ilist,103) zle
302   continue
c ............................................. Komplexe
      do 303 l=1,ncpl
      zle=' '
      zle(31:54)=lblcpl(l)
      xout=ccpl(l)*1.d6
      if(xout.gt.1.d-12) then
           write(zle(59:70),102) sngl(xout)
      else
           write(zle(59:70),102) xout
      endif
      write(zle(119:130),102) -sngl(dlog10(ccpl(l)
     $*gam(iabs(izcpl(l)))))
      write(ilist,103) zle
303   continue
c ............................................ Salze
      do 304 l=1,nslt
      zle=' '
      zle(31:56)=lblslt(l)(1:trmlen(lblslt(l)))//'-s'
      slt=(cslt(l)+offslt(l))*1.e6
      write(zle(59:70),102) sngl(slt)
ccc      if(ssr.gt.0.d0) then
ccc         slt=slt/1000.d0/ssr
ccc         write(zle(72:117),106) sngl(slt),sngl(slt-cslt0(l))
         dleta=slt-cslt0(l)*1000.*ssr
      if(delat.ne.0.d0)   write(zle(72:117),106) sngl(delta)
106      format('(   DELTA = ',g12.6,')')
ccc      endif
      xpk=0.
      do 602 l2=1,mptslt
      k=idfslt(l2*2-1,l)
      ff=idfslt(l2*2  ,l)
      if(k.eq.0) go to 603
      if(k.gt.0) xpk=xpk+ff*(-dlog10(ccat(k)*gam(izcat(k))))
      if(k.lt.0) xpk=xpk+ff*(-dlog10(cani(-k)*gam(izani(-k))))
602   continue
603   continue
      write(zle(119:130),102) xpk
      write(ilist,103) zle
304   continue
c ......................................... letzte zeile
      zle=' '
      zle(1:7)='I (1) ='
      write(zle(9:20),102) sngl(str)*1.e6
      if(nake.gt.0) then
         zle(21:31)=', AKe (1) ='
         write(zle(33:44),102) sngl(ake)*1.e6
      endif
      write(ilist,103) zle
      write(ilist,105) ('-',ll=1,130)
105   format(1x,130a1/)
      return
      end
