C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c VOLCHG
c Volumenaenderungen in BEM
c sei deltaCneu = (C + deltaCalt)*v1/v2  -  C
c parameter VOLINP in ml/L
c
      subroutine VOLCHG(dct,vol,volinp)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      dimension dct(mx)
c
      if(volinp.eq.0.d0) return
c
      volneu=vol+volinp*1.d-3
c
      do 201 l=2,ncat
      k=l-1
      ct=ctcat(l)+ctoff(k)
      dct(k)=(ct*vol+dct(k))/volneu - ct
201   continue
      do 202 l=2,nani
      k=ncat+l-2
      ct=ctani(l)+ctoff(k)
      if(l.ne.ico2) dct(k)=(ct*vol+dct(k))/volneu - ct
202   continue
c
      k=ncat+nani-1
      dct(k)=ake*vol/volneu-ake
c
      ssr=0.d0
c
      vol=volneu
      return
      end
