C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c     BEM Hauptprogramm: Verzweigung zu einzelnen Aufgaben
c
      program bem
      include 'inc001'
      dimension xx0(mx),res(mx),ires(mx)
      character subcom*8,buf*8/'        '/
      data ierbem/0/,iarg/0/
      call getarg(1,subcom)
      call getarg(2,buf)
      if(buf.ne.' ') read(buf,*)iarg 

      if(subcom.eq.'BEMP02') then
         call bemp02(ierbem)
      else if(subcom.eq.'BEMP03') then
         call bemp03(5,6,ierbem,iarg2)
      else if(subcom.eq.'BEMP04') then
         call bemp04(ierbem)
      else if(subcom.eq.'SHOW') then
         call show(iarg,ierbem)
      else if(subcom.eq.'BEMLINK') then
         call bmlink(ierbem)
      else if(subcom.eq.'RUN') then
         call getnvr(nvar)
         if (nvar.eq.0) then
            call bem01(5,6,56,0,xx0,ires,res,ierbem,0)
         else 
            call  bem01(5,6,56,0,xx0,ires,res,ierbem,1)
            do lvar=2,nvar
               if(ierbem.eq.0) then
                  call bem01(5,6,56,1,xx0,ires,res,ierbem,lvar)
               endif
            end do
         endif
      else if(subcom.eq.'BEMYIN') then
         call bemyin(ierbem)
      else if(subcom.eq.'TAB0') then
         call tab0(6,ierbem)
      else if(subcom.eq.'NOTE1') then
         call note1
      else
         call mess(100,subcom,r,i)
         call unxspc(3)
      endif
      if(ierbem.ne.0) call unxspc(3)
      end
