C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr BEMP02
c Ausgabe-Tabelle fuer BEM-Kette: Zeilen=Tiefen / Spalten=Zeiten
c
c BEM-Ergebnisse ueber ddnames ERG1, ERG2, ...
c Steueranweisungen ueber unit 5:
c    1.) Anzahl Horizonte
c    2.) Zeiten=Nummern der Batch-Schritte, die ausgegeben werden
c        sollen (1 Zeile, Angaben durch blanks getrennt)
c    3.) Variablen-Definition (1 Variable)
c
      subroutine bemp02(ierbem)
      include 'inc001'
      parameter (mtim=20)
      include 'inc002'
      character rec*80,tl*24,var*80,varlbl*24,fil*8
     b,fld*11,opt1*4
      dimension tl(30),varlbl(1),fld(mtim)
      integer ktim(mtim),ktyp(5,1)
      double precision x0(mx),xout(1),ctlc(mcat),ctla(mani)
      real out(mtim)
c
      read(5,100) opt1
      read(5,100) rec
      read(rec,*) nhor
      read(5,100) rec
100   format(a)
      call wktlst(rec,tl,ntim)
      if (ntim.gt.mtim) stop 'Zu viele Spalten verlangt.'
      do 201 L=1,ntim
201   read(tl(l),*) ktim(l)
      read(5,100) var
      inun=56
      ioutu=61
      open (unit=ioutu,file='liste')
c
      if(opt1.ne.'FILE') then
         write(ioutu,103) (ktim(ll),ll=1,ntim)
103      format(' z  \ t ',11(i5,6x))
         write(ioutu,102) ('_',ll=1,129)
102      format (1x,129a1)
      endif
c
      do 301 L1=1,nhor
         do 302 l2=1,ntim
302      out(l2)=-999.
         fil='ERG'
         call namnum(fil,L1)
         open(unit=inun,file=fil)
         read(inun,100) rec
         lvar=-1   ! 16.6.94
         call inpar(inun,0,6,lvar,ierbem)
         if(ierbem.ne.0) return
         call start(inun,0,1,ierbem)
         if(ierbem.ne.0) return
         call ppvar(var,ktyp(1,1),varlbl(1),ier)
         if (ier.ne.0) stop
         lout=1
310      call ppread(kstep,ltit,exch,inun,0,0,ierbem)
         if(ierbem.ne.0) return
         if (kstep.eq.-1) goto 311
309      if (ltit.eq.ktim(lout)) then
            call ctl(ctlc,ctla)
            call ppvcpt(ktyp(1,1),xout(1),ctlc,ctla,ltit,vol)
            out(lout)=xout(1)
            if (lout.ge.ntim) goto 311
            lout=lout+1
         else if (ltit.gt.ktim(lout)) then
            lout=lout+1
            if(lout.gt.ntim) goto 311
            goto 309
         endif
         call dctin ! 14.2.93
      goto 310
311   continue
      close (unit=inun)
      do 331 ll=1,ntim
      if (out(ll).gt.-998..or.opt1.eq.'FILE') then
         write(fld(ll),110) out(ll)
      else
         fld(ll)='     ?     '
      endif
331   continue
      write(ioutu,101) l1,(fld(ll),ll=1,ntim)
101   format(1x,i3,' | ',11(a11))
110   format(1x,g10.4)
      write(6,*) l1,'ter Horizont bearbeitet.'
301   continue
      stop
      end
