C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr EXPSET (BM-System)
c interpretiert Steuerzeilen, die den Experiment-Ablauf bestimmen
c
      subroutine expset(rec,nrep,exch,volinp,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      character tl*24,rec*80,var*24,upperc*80
      dimension tl(30)
      common /scrcom/ tl
c
      tl(1)=' '
      call wktlst(rec,tl,ntl)
      if (upperc(tl(1)).eq.'RUN') then
         call runset(rec,ierbem)
      else if (upperc(tl(1)).eq.'EXP') then
         do  L=1,mx
            ctin(L,1)=0.d0
            ctin(L,2)=0.d0
         end do
         do 201 L=2,ntl
         call varval(tl(L),var,val,1,ierbem)
         if(ierbem.ne.0) return
         if (var.eq.'NREP') then
            nrep=val
         else if (var.eq.'FLOW') then
            exch=val
         else if (var.eq.'VOLINP') then
            volinp=val
         else
ccc            write(6,9010) var,rec
            call mess(200,rec,r,i)
            ierbem=200
         endif
201      continue
      else if (upperc(tl(1)).eq.'CTIN') then
         do 203 L=2,ntl
         call vval3(tl(L),var,val,dval,0,ierbem)
         if(ierbem.ne.0) return
         do 204 l2=2,ncat
         if (var.eq.lblcat(l2)) then
            ctin(l2-1,1)=val
            ctin(l2-1,2)=dval
            goto 206
         endif
204      continue
         do 205 l2=2,nani
         if (var.eq.lblani(l2)) then
            if(l2.eq.ico2) then
               go to 206
            else
               ctin(ncat+l2-2,1)=val
               ctin(ncat+l2-2,2)=dval
               go to 206
            endif
         endif
205      continue
         if (upperc(var).eq.'PCO2'.and.ico2.gt.0) then
            ctin(ncat-2+ico2,1)=val
            ctin(ncat-2+ico2,2)=dval
            go to 206
         endif
ccc   write(6,9010) var,rec
         call mess(200,rec,r,i)
         ierbem=200
206      continue
203   continue
      else
ccc         write(6,9011) rec
         call mess(200,rec,r,i)
         ierbem=200
      endif
      return
c
      end
