C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr FXDFDX
      subroutine fxdfdx(x,nx,f,df,*)
      include 'inc001'
      include 'inc002'
      common /errcom/ nerr
      dimension x(mx),f(mx),df(mx,mx),dd(mx)
      do 202 l1=1,nx
      f(l1)=0.d0
      do 202 l2=1,nx
202   df(l1,l2)=0.d0
c ---------------------------------- Ionenst:arke --------------
      str=dexp(x(ki))
      rr=dsqrt(str)
      do 201 l=0,mz
      ff=-0.5d0*l**2*dlog(10.d0)
C     rgm(l)=ff*(rr/(1.d0+rr) - 0.3d0*str)  @  DAVIES - Gleichung
      rgm(l)=ff*(rr/(1.d0+rr) - 0.3d0*str)
Ccc   rgm(l)=ff*(rr/(1.d0+rr) )  @  G:UNTELBERG - Gleichung
ccc   rgm(l)=ff*(rr/(1.d0+rr) )
      drgm(l)=ff* (1.d0 / (2.d0*rr*(1.d0+rr)**2) - 0.3d0) * str
ccc   drgm(l)=ff* (1.d0 / (2.d0*rr*(1.d0+rr)**2)) * str
201   continue
      f(ki)= - str
      df(ki,ki)=df(ki,ki) - str
c
C     do 301 l=1,ncat @ ------------------- Kationen ------            -
      do 301 l=1,ncat
      ccat(l)=dexp(x(l)-rgm(izcat(l)))
      dl=ccat(l)
      dki=-ccat(l)*drgm(izcat(l))
C     f(1)=f(1) + izcat(l)*ccat(l)        @ ENB
      f(1)=f(1) + izcat(l)*ccat(l)
      df(1,l)=df(1,l) + izcat(l)*dl
      df(1,ki)=df(1,ki) + izcat(l)*dki
C     if(l.gt.1) then                  @ Bilanzen
      if(l.gt.1) then
           f(l)=-ctcat(l)+ccat(l)
           df(l,l)=df(l,l)+dl
           df(l,ki)=df(l,ki)+dki
      endif
C     fak=0.5d0*izcat(l)*izcat(l)     @ Ionenst:arke
      fak=0.5d0*izcat(l)*izcat(l)
      f(ki)=f(ki) + fak*ccat(l)
      df(ki,l)=df(ki,l)+fak*dl
      df(ki,ki)=df(ki,ki)+fak*dki
301   continue
c
C     xoh=eqw-x(1) @ ------------------- Anionen -----------------------
      xoh=eqw-x(1)
      cani(1)=dexp(xoh-rgm(1))
      d1=-cani(1)
      dki=cani(1)*drgm(1)
C     f(1)=f(1)-cani(1)       @ OH: ENB
      f(1)=f(1)-cani(1)
      df(1,1)=df(1,1)-d1
      df(1,ki)=df(1,ki)-dki
C     f(ki)=f(ki)+0.5*cani(1) @ OH: I
      f(ki)=f(ki)+0.5*cani(1)
      df(ki,1)=df(ki,1)+0.5d0*d1
      df(ki,ki)=df(ki,ki)+0.5d0*dki
      do 302 l=2,nani
      k=kani+l-2
      cani(l)=dexp(x(k)-rgm(izani(l)))
      dl=cani(l)
      dki=-cani(l)*drgm(izani(l))
C     f(1)=f(1) - izani(l)*cani(l)        @ ENB
      f(1)=f(1) - izani(l)*cani(l)
      df(1,k)=df(1,k) - izani(l)*dl
      df(1,ki)=df(1,ki) - izani(l)*dki
C      f(k)=-ctani(l)+cani(l)   @ Bilanzen
       f(k)=-ctani(l)+cani(l)
       df(k,k)=df(k,k)+dl
       df(k,ki)=df(k,ki)+dki
C     fak=0.5d0*izani(l)*izani(l)     @ Ionenst:arke
      fak=0.5d0*izani(l)*izani(l)
      f(ki)=f(ki) + fak*cani(l)
      df(ki,k)=df(ki,k)+fak*dl
      df(ki,ki)=df(ki,ki)+fak*dki
302   continue
c ----------------------------------------- Komplexe -----------------
      do 401 l1=1,ncpl
      xc=-eqcpl(l1)
      iz=iabs(izcpl(l1))
      do 404 l=1,nx
404   dd(l)=0.d0
      do 402 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      ff=idfcpl(l2*2,l1)
      if(k.eq.0) then
           go to 403
      else if (k.gt.0) then
           xc=xc + ff*x(k)
           dd(k)=dd(k)+ff
      else if (k.eq.-1) then
           xc=xc+ff*xoh
           dd(1)=dd(1)-ff
      else
           k=kani-k-2
           xc=xc+ff*x(k)
           dd(k)=dd(k)+ff
      endif
402   continue
403   continue
      ccc=xc-rgm(iz)
      if (ccc.lt.-177.23) then
         ccpl(l1)=.999d-77
      else
         ccpl(l1)=dexp(ccc)
      endif
C     f(1)=f(1)+izcpl(l1)*ccpl(l1)              @ ENB
      f(1)=f(1)+izcpl(l1)*ccpl(l1)
      do 405 l2=1,nx
405   df(1,l2)=df(1,l2)+izcpl(l1)*ccpl(l1)*dd(l2)
      df(1,ki)=df(1,ki)-izcpl(l1)*ccpl(l1)*drgm(iz)
c Schleife :uber Komplexkomponenten wg. Elementbilanzen
      do 406 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      ff=idfcpl(l2*2,l1)
C     if(k.eq.0) go to 407  @ keine weiteren Komponenten des Komplexes
      if(k.eq.0) go to 407
C     if(k.eq. 1) go to 406 @ Komponente = H
      if(k.eq. 1) go to 406
C     if(k.eq.-1) go to 406 @ Komponente = OH
      if(k.eq.-1) go to 406
C     if(k.lt.-1) k=kani-k-2 @ Anion - Komponente
      if(k.lt.-1) k=kani-k-2
C     f(k)=f(k) + ff*ccpl(l1) @ Elementbilanz
      f(k)=f(k) + ff*ccpl(l1)
      do 408 l3=1,nx
408   df(k,l3)=df(k,l3) + ff*ccpl(l1)*dd(l3)
      df(k,ki)=df(k,ki) -ff*ccpl(l1)*drgm(iz)
406   continue
407   continue
      ff=0.5d0*iz**2
      f(ki)=f(ki)+ff*ccpl(l1)
      do 409 l2=1,nx
409   df(ki,l2)=df(ki,l2)+ff*ccpl(l1)*dd(l2)
      df(ki,ki)=df(ki,ki)-ff*ccpl(l1)*drgm(iz)
401   continue
c ..................................... Kationenaustausch
      if(kex.eq.0) go to 600
      xs(1)=dexp(x(kex))
      f(kex)=-1.d0+xs(1)
      df(kex,kex)=xs(1)
      do 501 l=2,ncat
      if (exform.eq.'GAP') then
           frm=1.d0
      else
           frm=izcat(l)
      endif
      q=( x(l)/izcat(l) -x(1) +x(kex) -eqex(l) )*frm
      xs(l)=dexp(q)
      f(kex)=f(kex) + xs(l)
      df(kex,  l)=df(kex,  l) + xs(l)/izcat(l)  *frm
      df(kex,  1)=df(kex,  1) - xs(l)           *frm
      df(kex,kex)=df(kex,kex) + xs(l)           *frm
      f(  l)=f(  l) + xs(l)*ake/izcat(l)
      df(  l,  l)=df(  l,  l) + xs(l)*ake/(izcat(l)**2) *frm
      df(  l,  1)=df(  l,  1) - xs(l)*ake/izcat(l) *frm
      df(  l,kex)=df(  l,kex) + xs(l)*ake/izcat(l) *frm
501   continue
c
c .......................... Salze (L:oslichkeitsgleichgewichte)
600   continue
      if (nslt.eq.0) go to 700
      do 601 l1=1,nslt
      ks=kslt+l1-1
      if (iswslt(l1).le.0) then
ccc        f(ks)=x(ks)-eqslt(l1)
           f(ks)=x(ks)-1.d0        !!! neu 10.8.91
           df(ks,ks)=1.d0
           cslt(l1)=0.d0   !!!!!! neu 7.8.91
           go to 601
      endif
      cslt(l1)=dexp(x(ks))
      if(int(pkslt(l1)).eq.10000) then
         call sfc1(pkl,dpkl,l1)
         eqslt(l1)=-pkl*dlog(10.d0)
         df(ks,ks)=dpkl*cslt(l1)*dlog(10.d0)
      else if(int(pkslt(l1)).eq.20000) then
         call sfc2(pkl,dpkl,l1)
         eqslt(l1)=-pkl*dlog(10.d0)
         df(ks,ks)=dpkl*cslt(l1)*dlog(10.d0)
      else if(int(pkslt(l1)).eq.30000) then
         call sfc4(pkl,dpkl,l1)
         eqslt(l1)=-pkl*dlog(10.d0)
         df(ks,ks)=dpkl*cslt(l1)*dlog(10.d0)
      else if(int(pkslt(l1)).eq.40000) then
         call sfc5(pkl,dpkl,l1)
         eqslt(l1)=-pkl*dlog(10.d0)
         df(ks,ks)=dpkl*cslt(l1)*dlog(10.d0)
      endif
      f(ks)=-eqslt(l1)
      do 602 l2=1,mptslt
      ke=idfslt(l2*2-1,l1)
      ff=idfslt(l2*2  ,l1)
      if(ke.eq.0) then
           go to 603
      else if (ke.eq.1) then
           f(ks)=f(ks) + ff*x(1)
           df(ks,1)=df(ks,1) + ff
      else if (ke.eq.-1) then
           f(ks)=f(ks) + ff*xoh
           df(ks,1)=df(ks,1) - ff
      else
           if (ke.lt.-1) ke=kani-ke-2
           f(ks)=f(ks) + ff*x(ke)
           df(ks,ke)=df(ks,ke) + ff
           f(ke)=f(ke) + ff*cslt(l1)
           df(ke,ks) = df(ke,ks) + ff*cslt(l1)
      endif
602   continue
603   continue
ccc      if (f(ks).gt.150) then
ccc         print *,'FXDFDX(1):',cslt(l1),eqslt(l1)
ccc      endif
      ehf=dexp(f(ks))
      f(ks)=ehf-1.d0     !!! neu 10.8.91
      do l=1,mx                  !!!     "
         df(ks,l)=ehf*df(ks,l) !!!     "
      end do                     !!!     "
601   continue
c
c .......................... next feature
      if(nerr.gt.0) return 1
700   continue
c .......................... CO2 - Partialdruck angegeben
1000  continue

      if(nerr.gt.0) return 1

      if(ico2.eq.0) return
      k=kani-2+ico2
      f(k)=-ctani(ico2)*10.d0**(-pkco2(1)) +ccpl(ih2co3)
      do 1001 l=1,nx
1001  df(k,l)=0.d0
      df(k,1)=ccpl(ih2co3)*2.d0
      df(k,k)=ccpl(ih2co3)
      if(nerr.gt.0) return 1
      return
      end
