C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr NXTPNT
c Homotopieverfahren und Iteration f:ur n:achsten Punkt der Trajektorie
c
      subroutine nxtpnt(dct,k01,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc004'
      include 'inc005'
      dimension x(mx),dh(mx),xold(mx),sold(mx),ct1(mx),ct2(mx)
     2,dct(mx),iswold(mslt),oldoff(mslt)
      data ntot/0/,iersws/0/
     b,x/mx*0.d0/ ,xold/mx*0.d0/,sold/mx*0.d0/
     c,ct1/mx*0.d0/,ct2/mx*0.d0/
     d,iswold/mslt*0/,oldoff/mslt*0.d0/,alfold/0.d0/
c
      kscl=1
      if(k01.eq.0) go to 200
      go to 300
c
c
C     ............. nullter Aufruf
 200  continue
      ntt=0
      nx=ncat+nani+nake+nslt
      do  l=1,nx
         x(l)=x0(l)
      end do
      call unxspc(1)
      call hxdhdx(nx,x,h,dh,*900)
      call unxspc(2)
      krst=neusta*2
      alfa=0.d0
      dalf=1.0d0
      f10=-1.d0/dlog(10.d0)
      do l=2,ncat
         k=l-1
         ct1(k)=ctcat(l) +ctoff(k)
         if(ct1(k).le.0.d0) then 
            call mess(217,lblcat(l),r,i)
            ierbem=217
            return
         endif 
      end do  
      do l=2,nani
         k=ncat+l-2
         ct1(k)=ctani(l) + ctoff(k)
         if(ct1(k).le.0.d0) then 
            call mess(217,lblani(l),r,i)
            ierbem=217
            return
         endif   
      end do
      ct1(ncat+nani-1)=ake
      go to 420         
c     
 300     continue
      ntt=0
      alfa=dalf
      alfold=0.d0
      krst=neusta
      do 301 l=1,nx
301   ct2(l)=ct1(l)+dct(l)
c
400   continue
      a=dmin1(alfa,1.d0)
      alfa=a
      call actoff
      do 401 l=2,ncat
         k=l-1
         ctcat(l)=(1.d0-a)*ct1(k) + a*ct2(k) - ctoff(k)
         if(ctcat(l).le.0.d0) then 
            call mess(217,lblcat(l),r,i)
            ierbem=217
            return
         endif
401   continue
      do 402 l=2,nani
         k=ncat+l-2
         ctani(l)=(1.d0-a)*ct1(k) + a*ct2(k) - ctoff(k)
         if(ctani(l).le.0.d0) then
            call mess(217,lblani(l),r,i)
            ierbem=217
            return
         endif
402   continue
      k=ncat+nani-1
      if(nake.gt.0) ake= (1.d0-a)*ct1(k) + a*ct2(k)
420   ntot=0
      nstr=0
410   nstr=nstr+1
      if(nstr.gt.krst) then
           if(k01.eq.0) then
                call mess(303,c,r,i)
                ierbem=303
                return
           endif
           go to 500
      endif
      if (kscl.gt.0) call sclupd
      kscl=1
      nvar=nx
      hold=h
c
      call meth1(nvar,x,ier,h,nlast)
c
      ntot=ntot+nlast
      ntt=ntt+nlast
      if(ntt.ge.kpmd) then
         call mess(302,c,r,ntt)
         ierbem=302
         return
      endif
      if(ier.eq.3) then
         if(k01.gt.0) then
            if(kls.ge.2) write(itrace,102) k01,ntt,ier,-1,h,alfa
     b           ,dalf,(iswslt(ll),ll=1,nslt)
            goto 500
         else
            call mess(301,c,r,i)
            ierbem=301
            return
         endif
      endif
      ierctr=ier
      call contrl(relerr,ierctr)
      xph=x(1)*f10

ccc      if(kls.ge.2) write(itrace,102) ntt,h,ier,ierctr,ntot,xph,alfa
ccc     b,dalf,(iswslt(ll),ll=1,nslt)
ccc102   format(' T02: ',i6,1x,g10.4,1x,i2,1x,i5,1x,i5,1x,f8.5,2f9.6
ccc     b,1x,10i1)

      if(kls.ge.2) write(itrace,102) k01,ntt,ier,ierctr,h,alfa
     b     ,dalf,(iswslt(ll),ll=1,nslt)
 102  format(' ...>',i5,'  n=',i6,'  i=',i2,'/',i3,'  h=',g10.4E2
     b     ,'  a=',g9.3E2,'+',g9.3E2,' s=',10I1)




      if (ierctr.eq.0) then
         call swsalt(1,iersws)
      endif
      if(iabs(iersws).ge.6000) then
         if (iersws.gt.6000) then
            ls=iersws-6000
            ks=kslt+ls-1
            x(ks)=dlog(wptslt(ls))
         endif
         iersws=0
         go to 400
      endif
      if(ierctr.ne.0) go to 410
      call wptset        !!!!! neu 5.8.91
      if(k01.eq.0) then
         do l=1,nx
            x0(l)=x(l)
         end do
      endif
      do 411 l=1,nx
      xold(l)=x(l)
411   sold(l)=scl(l)
      do 412 l=1,nslt
      oldoff(l)=offslt(l)
412   iswold(l)=iswslt(l)
       if(alfa.ge.1.d0) go to 600
      if(k01.eq.0) go to 610
      alfold=alfa
      dalf=dalf*1.1d0
      alfa=dmin1(1.d0,alfa+dalf)
      go to 400
c
C00   continue @ ................... zur:uck|
500   continue 
      do 501 l=1,nx
      x(l)=xold(l)
501   scl(l)=sold(l)
      do 502 l=1,nslt
      offslt(l)=oldoff(l)
502   iswslt(l)=iswold(l)
      call sltrst
      kscl=0
      dalf=0.5d0*dalf
      alfa=dmin1(1.d0,alfold+dalf)
      go to 400
c
C                       ------------------------------ return
600   continue
      do 601 l=1,nx
601   ct1(l)=ct2(l)
650   if(kls.gt.0) write(itrace,101) k01,ntt,ier,ierctr,h,xph
ccc101   format(' T01 (Gleichgewicht ',i4,'): ',i8,1x,g12.6,1x,g12.6)
 101  format(' EQL ',i5,'  n=',i6,'  i=',i2,'/',i3,'  h=',g10.4E2
     b     ,'  pH=',g12.6E2)

      return
610   continue
ccc      do 611 l=2,ncat
ccc      k=l-1
ccc611   ct1(k)=ctcat(l) + ctoff(k)
ccc      do 612 l=2,nani
ccc      k=ncat+l-2
ccc612   ct1(k)=ctani(l) + ctoff(k)
ccc      ct1(ncat+nani-1)=ake
      go to 650
c
 900  call mess(301,c,r,i)
      ierbem=301
      return
      end
