C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr partab
c schreibt Tabelle der eingelesenen Modelldefinitionen
c
      subroutine partab(iout)
      include 'inc001'
      include 'inc002'
c
      write(iout,101)
101   format(////1x,'Modell - Definitionen'/
     2         1x,'====================='/)
      write(iout,102) 'Kationen: '
102   format('0',a10,t15,'Nr.',t20,'  Name',t30,'z')
      if (nake.gt.0) write(iout,111)
111   format('+',t35,'pK-ex(/H)')
      write(iout,112) ('-',ll=1,60)
112   format(1x,60a1)
      do 201 l=1,ncat
      write(iout,103) l,lblcat(l),izcat(l)
103   format(1x,t15,i2,t20,a8,t30,i3)
      if (nake.gt.0.and.l.gt.1) write(iout,110) pkgap(l)
110   format('+',t35,f8.3)
201   continue
      write(iout,106) 'Anionen: ',('-',ll=1,60)
106   format('0',a10,t15,'Nr.',t20,'  Name',t30,'z'
     2/1x,60a1)
      do 202 l=1,nani
202   write(iout,103) l,lblani(l),-izani(l)
      write(iout,104) ('-',ll=1,60)
104   format('0Komplexe:',t15,'Nr.',t20,'   Formel',t50,'z'
     2,t58,'pK'/1x,60a1)
      do 203 l=1,ncpl
203   write(iout,105)l,lblcpl(l),izcpl(l),pkcpl(l)
105   format(1x,t15,i3,t20,a24,t50,i3,t55,f8.3)
c
      if(nake.gt.0)
     b   write(iout,107) ('-',ll=1,60),'Kationenaustausgleichgewicht'
     c,'-Typ: ',exform
     d      ,('-',ll=1,60)
107   format (1h0,60a1/1x,3a/1x,60a1)
c
      if (nslt.gt.0) then
         write(iout,108)('-',ll=1,60)
108      format(/'0Salze',t15,'Nr.',t20,'Formel',t53,'pK-L'
     2      /60a1)
         do 204 l=1,nslt
204      write(iout,109) l,lblslt(l),pkslt(l)
109      format(t15,i3,t20,a24,t50,f8.3)
      endif
      return
      end
