C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr ppread
c liest Daten vom Ergebnis-File zu bcm1
c
      subroutine ppread(kstep,ltit,exch,iunit,ilst,iout,ierbem)
c ARGUMENT iout = neu am 7.3.92 (wg. Uebergabe von *SKIP)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc004'
      character rec*80,upperc*80
300   read(iunit,100,end=902,err=901) rec


100   format(a)
      if(rec(1:3).eq.'RES') then
         read(rec(4:80),*) ltit
102      format(3x,i8)
         goto 301
      else if(rec(1:1).eq.'*') then
         if(ilst.gt.0) write (ilst,110) 'Kommentar: ',rec
         if(iout.ne.0) write (iout,101) rec
110      format(1x,20(1h.),'> ',2a)
         goto 300
      else if(upperc(rec(1:3)).eq.'END') then
         if(iout.ne.0) write (iout,101) rec
         goto 400
      else
         if(iout.ne.0) write (iout,101) rec
         ier=0
         call expset(rec,nrep,exch,volinp,ierbem)
         if (ierbem.ne.0) return
         if(ilst.gt.0.and.upperc(rec(1:3)).ne.'RUN')
     b    write (ilst,110) 'Versuchsablauf: ',rec
      endif
 101  format(' >>> ',a70)
      goto 300
301   kstep=kstep+1
      call rdeql(iunit,ierrd)
      if(ierrd.eq.-1) go to 901
      if(ierrd.eq.+1) go to 902
      call restor

      if (ltit.eq.0) then
         do ll=1,mslt
            offslt(ll)=0.d0
         end do
      endif
      call contrl(relerr*1.d3,ier)
ccc      print *,'PPREAD / contrl ->',ier
      if(ier.ne.0) then
         call mess(402,c,r,ier)
         ierbem=402
         return
      endif
      return
c     .......................................................
 400  continue
      kstep=-1
      return
c.....................................
901   call mess(403,c,r,i)
      ierbem=403
      go to 400
902   call mess(404,c,r,i)
      ierbem=404
      go to 400
      end
