C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c SFC1 = special function 1
c das Loeslichkeitsprodukt von AlOHSO4 wird als Funktion der
c AlOHSO4 - Menge aufgefasst  pK= a * exp(-b*x) + c
c     mit a,b,c Konstanten, die ueber eine PAR1 - Zeile angegeben werden
c     und x= Aenderung der AlOHSO4-Menge seit Spielbeginn
c ----------------------------------------------------------------------
      subroutine sfc1(pkl,dpkl,islt)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc007'
c ---------------------------------------------------------------------
      x=(cslt(islt)+offslt(islt))*1000.d0/ssr - cslt0(islt)
ccc   print *,'SFC1:',cslt(islt),offslt(islt),cslt0(islt)
      pkl=par1a*dexp(-par1b*x)+par1c
      dpkl=-par1a*par1b*dexp(-par1b*x)*1000.d0/ssr
ccc   print *,'SFC1: ',x,pkl,dpkl
      return
      end
