C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c SFC2 = special function 2
c das Loeslichkeitsprodukt von AlOHSO4 wird als Funktion der
c AlOHSO4 - Menge aufgefasst  pK= a + b/(c+x)
c     mit a,b,c Konstanten, die ueber eine PAR1 - Zeile angegeben werden
c     und x= Aenderung der AlOHSO4-Menge seit Spielbeginn
c ----------------------------------------------------------------------
      subroutine sfc2(pkl,dpkl,islt)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc007'
c ---------------------------------------------------------------------
      x=(cslt(islt)+offslt(islt))*1000.d0/ssr - cslt0(islt)
ccc   print *,x,cslt(islt)*1000/ssr,offslt(islt)*1000/ssr,cslt0(islt)
      pkl=par1a + par1b/(x+par1c)
      dpkl=-par1b/((par1c+x)*(par1c+x))*1000.d0/ssr
      return
      end
