C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c SFC4 = special function 4
c das Loeslichkeitsprodukt von AlOHSO4 wird als Funktion der
c AlOHSO4 - Menge aufgefasst  pK= a(x-c)**2 + b ; fuer x<c
c                             pK= b             ; fuer x=>c
c     mit a,b,c Konstanten, die ueber eine PAR1 - Zeile angegeben werden
c     und x= Aenderung der AlOHSO4-Menge seit Spielbeginn
c ----------------------------------------------------------------------
      subroutine sfc4(pkl,dpkl,islt)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc007'
c ---------------------------------------------------------------------
      x=(cslt(islt)+offslt(islt))*1000.d0/ssr - cslt0(islt)
ccc   print *,x,cslt(islt)*1000/ssr,offslt(islt)*1000/ssr,cslt0(islt)
ccc   pkl=par1a + par1b/(x+par1c)
ccc   dpkl=-par1b/((par1c+x)*(par1c+x))*1000.d0/ssr
      if(x.lt.par1c) then
         pkl=par1a*(x-par1c)**2 + par1b
         dpkl=par1a*2.d0*(x-par1c)*1000.d0/ssr
      else
         pkl=par1b
         dpkl=0.d0
      endif
      return
      end
