C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c SFC5 = special function 5
c das Loeslichkeitsprodukt von AlOHSO4 wird als Funktion der
c AlOHSO4 - Menge aufgefasst  pK= f(x), wobei f eine Spline-Funktion ist:
c    zwischen x1 und x2 ist f ein Polynom dritten Grades mit vorgeschriebenen
c    Werten fuer y1=f(x1), y2=f(x2), d1=f'(x1) und d2=f'(x2). Ausserhalb
c    von [x1,x2] wird f durch lineare Funktionen fortgesetzt, die in x1 und x2
c    die gleichen Funktionswerte und ersten Ableitungen haben.
c    die Konstanten x1,y1,d1,x2,y2,d2 werden ueber eine P01 - Zeile
c    eingegeben.  x= Aenderung der AlOHSO4-Menge seit Spielbeginn
c ----------------------------------------------------------------------
      subroutine sfc5(pkl,dpkl,islt)
      include 'inc001'
      include 'inc002'
      include 'inc003'
c ---------------------------------------------------------------------
      x=(cslt(islt)+offslt(islt))*1000.d0/ssr - cslt0(islt)


      call getspl(x,pkl,dpkl)

      return
      end
