C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr STAB Kurztabelle eines Gleichgewichts von BEM
c ersetzt sr TABCAS bei Bildschirmbenutzung
c
      subroutine stab(ktab,cpllim,iun,ierbem)
      parameter (mlin=40)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      dimension ctlc(mcat),ctla(mani)
      character*79 tab(mlin)
      integer trmlen
c
      if(ncat+nani+nslt+1.gt.mlin) goto 901
      do 201 L=1,mlin
201   tab(L)=' '
      write(iun,121) ktab
ccc121   format(1x,'Gleichgewicht Nr. ',i5,':')
121   format(1x,'equilibrium of step no. ',i5,':')
      write(iun,122)
122   format(t8,'umol(ttl)/L  umol(ion)/L',t37,'%',t44,'|'
     b,t69,'umol(cpl)/L')
      call ctl(ctlc,ctla)
c
      write(tab(1)(2:9),100) 'H   (pH='
100   format(a)
      write(tab(1)(22:31),101) ccat(1)*1.d6
      write(tab(1)(10:19),102) -dlog10(ccat(1)*gam(1))
101   format(g10.4)
102   format(f6.3,')')
      do 301 L=2,ncat
      write(tab(L)(2:9),100) lblcat(L)
      write(tab(L)(11:20),101) ctlc(L)*1.d6
      write(tab(L)(22:31),101) ccat(L)*1.d6
301   continue
      if (nake.gt.0) then
         do 302 L=1,ncat
         write(tab(L)(33:42),101) xs(L)*100.d0
302      continue
      endif
      line=ncat+1
      write(tab(line)(2:9),100) 'OH'
      write(tab(line)(22:31),101) cani(1)*1.d6
      do 303 L=2,nani
      line=L+ncat
      write(tab(Line)(2:9),100) lblani(L)
      write(tab(Line)(11:20),101) ctla(L)*1.d6
      write(tab(Line)(22:31),101) cani(L)*1.d6
303   continue
      do 304 L=1,nslt
      line=ncat+nani+L
      write(tab(line)(2:31),100) lblslt(L)(1:trmlen(lblslt(L)))
     b//'-s'
      write(tab(line)(33:42),101) (cslt(L)+offslt(L))*1.d6
304   continue
c
      line=line+1
      write(tab(line)(2:  ),100) 'Ionenstaerke'
      write(tab(line)(22:31),101) str*1.d6
c
      line=0
      do 401 L=1,ncpl
      if(L.eq.ih2co3) then
         line=line+1
         if(line.gt.mlin) goto 901
         write(tab(line)(45:50),100) 'PCO2 ='
         write(tab(line)(52:59),103) ctani(ico2)*1.d3
103      format(f8.3)
         write(tab(line)(61:64),100) 'mbar'
      else
         x=ccpl(L)*1.d6
         if (x.gt.cpllim) then
            line=line+1
            if (line.gt.mlin) goto 901
            write(tab(line)(45:68),100) lblcpl(L)
            write(tab(line)(70:79),101) x
         endif
      endif
401   continue
c
      nlin=max(ncat+nani+nslt+1,line)
      do 501 L=1,nlin
      tab(L)(44:44)='|'
501   write(iun,100) tab(L)
      return
c
c Fehlernachrichten
c
ccc901   write(6,9010)
ccc9010  format (' ***** Tabellenueberlauf *****')
ccc      stop 1

 901  call mess(412,c,r,mlin)
      ierbem=412
      return

      end
