C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr START
c liest Anfangswerte 
c
      SUBROUTINE START(imod,irfile,lvar,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc005'
      character cf1*24, cbuf*12,abuf*12,upperc*80
     b,rec*80,inp*80,cmtlbl*80
      dimension cbuf(mcat),abuf(mani)
      common /scrcom/ cbuf,abuf,inp
c
c --------------------------------- Startwerte initialisieren
c
      nct=ncat+nani-2
      ssr=-999.
      pco2=-999.
      estph=-999.
      estxsh=-999.
      eststr=-999.
      do 221 l=1,nct
 221     estcon(l)=-999.
         do 222 l=1,nslt
 222        estslt(l)=-999.d0
            do 211 l=1,nct
 211           ctl0(l)=-999.
      ak=-999.
      do 212 l=1,ncat
      cex(l)=-999.d0
212   xs0(l)=0.d0
      do 213 l=1,nslt
      cslt0(l)=-999.
213   wptslt(l)=-999.
      kextyp=0
c
c Startwerte lesen ...........................
c
200   read(imod,100)inp
      call brcint(inp,rec,lvar,n)
      if(n.gt.0.and.irfile.gt.0) write(irfile,100) cmtlbl(inp)
100   format (a)
      if (irfile.gt.0) write(irfile,100) rec
      if (rec(1:1).eq.'*') then
         goto 200
      else if (upperc(rec(1:3)).eq.'RUN') then
         call runset(rec,ierbem)
         if(ierbem.ne.0) return
         goto 200
      else if (upperc(rec(1:3)).ne.'END') then
         call strset(rec,kextyp,ierbem)
         if(ierbem.ne.0) return
         go to 200
      endif

      if(kextyp.eq.2) then
         call cexint(estph,eststr,estcon(1),ierbem)
         if(ierbem.ne.0) return
         estxsh=xs0(1)
      endif
c Vollstaendigkeit der Angaben testen
      call strtst(ierbem)
      if(ierbem.ne.0) return
c
c
c --------------------------------- Umrechnen auf interne Werte
c
300   continue
      if(ico2.gt.0) then
           ctl0(ncat+ico2-2)=pco2*1.d3
      endif
      do 306 l=1,nslt
      cslt(l)=cslt0(l)*ssr*1.d-3 ! neu 18. 9 .91
      estslt(l)=estslt(l)*ssr*1.d3 ! neu 28.12.93
c wenn WPTSLT-Angabe fehlt, fuer Startpunkt ESTSLT nehmen (8.8.91)
      if (iwpfix(l).eq.0) wptslt(l)=estslt(l)
306   wptslt(l)=wptslt(l)*1.d-6
      call swsalt(0,ndum)
      call actoff
      do 301 l=2,ncat
      k=l-1
301   ctcat(l)=ctl0(k)*1.d-6 - ctoff(k)
      do 302 l=2,nani
      k=ncat+l-2
302   ctani(l)=ctl0(k)*1.d-6 - ctoff(k)
      if (nake.gt.0) then
         ake=ak*ssr *1.d-3
         do 303 l=2,ncat
303      ctcat(l)=ctcat(l)+xs0(l)*ake/izcat(l)
      endif
      if (nslt.gt.0) then
         do 304 l1=1,nslt
         do 305 l2=1,mptslt
         k=idfslt(l2*2-1,l1)
         f=idfslt(l2*2  ,l1) *1.d-3
         if(k.eq.0) go to 304
         if(k.eq.1) go to 305
         if(k.eq.-1) go to 305
         if(k.eq.-ico2) go to 305
         if(k.lt.-1) then
            ctani(-k)=ctani(-k)+cslt0(l1)*ssr*f
         else
            ctcat(k)=ctcat(k)+cslt0(l1)*ssr*f
         endif
305        continue
304        continue
      endif
c
      str=eststr*1.d-6
      do 401 l=0,mz
401   gam(l)=10.d0**
     2 (-0.5d0*(l*l)*(dsqrt(str)/(1.d0+dsqrt(str))-0.3d0*str))
      x0int(1)=-estph*dlog(10.d0)
      do 402 l=2,ncat
      k=l-1
      x0int(l)=dlog(estcon(k)*gam(izcat(l))*1.d-6)
402   continue
      do 403 l=2,nani
      k=ncat+l-2
      k2=ncat+l-1
      x0int(k2)=dlog(estcon(k)*gam(izani(l))*1.d-6)
403   continue
      x0int(ki)=dlog(eststr*1.d-6)
      if(nake.gt.0) then
         x0int(kex)=dlog(estxsh)
      endif
      do 404 l=1,nslt
      if(estslt(l).gt.0.d0) then
         iswslt(L)=1
         x0int(kslt+l-1)=dlog(estslt(l)*1.d-6)
      else
         x0int(kslt+l-1)=1.d0 
         iswslt(L)=0
      endif
404   continue
      do 410 l=1,mx
410   scl(l)=1.d0
c
      return
      end
