C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr STATAB
c Tabelle der Anfangskonzentrationen und Startwerte
c
      SUBROUTINE STATAB(ilist)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc005'
      character cf1*24, cbuf*12,abuf*12,upperc*80,rec*80
      dimension cbuf(mcat),abuf(mani)
      common /scrcom/ cbuf,abuf
c
      do 204 l=2,ncat
      k=l-1
204   write(cbuf(l),113) ctl0(k)
113   format(g12.6)
      do 205 l=2,nani
      k=ncat+l-2
      if(l.eq.ico2) then
         abuf(l)='   ---------   '
      else
         write(abuf(l),113) ctl0(k)
      endif
205   continue
c
      write(ilist,101)
101   format(//1h0,'Definition der Elementmengen im Anfangszustand'/
     b       1h ,'=============================================='/
     c' a) gel:ost (mikromol/l):')
      write(ilist,102)(cf1(lblcat(ll)),cbuf(ll),ll=2,ncat)
     b           ,(cf1(lblani(ll)),abuf(ll),ll=2,nani)
102   format(1x,6(a8,': ',a12))
      if(nslt.gt.0.or.nake.gt.0) then
           write(ilist,103) ssr
103        format('0b) Festphase: (SSR=) ',g12.6,' kg/l')
           if(nake.gt.0) then
                write(ilist,104) ak
104             format(' AKe = ',g12.6,' mmol(eq)/kg, austauschbare',
     b          ' Kationen (xs-Werte):')
                write(ilist,105)(cf1(lblcat(ll)),xs0(ll),ll=1,ncat)
105             format(1x,6(a8,': ',f6.4))
                write(ilist,*)
            endif
            do 201 l=1,nslt
201         write(ilist,106) cf1(lblslt(l)),cslt0(l),wptslt(l)
106         format(1x,a24,'-s = ',g12.6,' mmol/kg (Arbeitspunkt :'
     b      ,g12.6,')')
      endif
      if(ico2.gt.0) then
           ctl0(ncat+ico2-2)=pco2*1.d3
           write(ilist,107) pco2
107        format('0c) Gasphase: CO2-Partialdruck = konstant = '
     b     ,g12.6,' mbar')
      endif
c---------------------------------------------------------------------
      write(ilist,108)
108   format(//1h0,'Startpunkt des Iterationsverfahrens'/
     b      ,1x ,'==================================='/)
      write(ilist,109) estph,eststr
109   format(' pH: ',f6.3
     &,',   Ionenst:arke: ',g12.6,' mikromol/l')
      write(ilist,110)
110   format(/' Konzentrationen der Basis-Ionen (mikromol/l):')
      do 206 l=2,ncat
      k=l-1
      write(ilist,121) lblcat(l),estcon(k)
121   format(1x,a8,': ',g12.6)
206   continue
      do 207 l=2,nani
      k=ncat+l-2
      write(ilist,121) lblani(l),estcon(k)
207   continue
      if(nake.gt.0) write(ilist,111) estxsh
111   format(/' xs(H): ',g12.6/)
      do 202 l=1,nslt
202   write(ilist,112) cf1(lblslt(l)), estslt(l)
112   format(1x,a24,'-s  (Salzmenge ohne OFFSET in mikromol/l): '
     &,g12.6)
      write(ilist,'(////)')
c-----------------------------------------------------------------------
      return
      end
