C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c XMERGE
c merge real vector X into real vector Y (X,Y already sorted)
c
c      program tstxmg
c      dimension x(20),y(20)
c 200  print *,'TSTXMG, enter ny \\ y \\ nx \\ x'
c      read (5,*,end=800) ny
c      read (5,*,end=800) (y(ll),ll=1,ny)
c      read (5,*,end=800) nx
c      read (5,*,end=800) (x(ll),ll=1,nx)
c      print *, (y(ll),ll=1,ny)
c      print *, (x(ll),ll=1,nx)
c      call xmerge(y,ny,x,nx)
c      print *, (y(ll),ll=1,ny)
c      print *
c      go to 200
c 800  stop
c      end
c
c
c
      subroutine xmerge(y,ny,x,nx)
      implicit double precision(a-h,o-z)
      logical xgt
      dimension y(ny),x(nx)
c
      do l1=1,nx
         do l2=1,ny
            if(xgt(y(1),x(l1))) then
               do l3=ny,1,-1
                  y(l3+1)=y(l3)
               end do
               ny=ny+1
               y(1)=x(l1)
            else if(xgt(x(l1),y(ny))) then
               ny=ny+1
               y(ny)=x(l1)
            else if (xgt(y(l2),x(l1)).and.xgt(x(l1),y(l2-1))) then
               do l3=ny,l2,-1
                  y(l3+1)=y(l3)
               end do
               ny=ny+1
               y(l2)=x(l1)
            end if
         end do
      end do
      return
      end
c
c
c
c XGT(A,B) test of "A.gt.B"
      logical function xgt(a,b)
      data eps/1.e-6/
      c=abs(b)
      if (c.lt.eps) then
         x=a-b
      else
         x=(a-b)/c
      endif
      if (x.gt.eps) then
         xgt=.true.
      else
         xgt=.false.
      endif
ccc      print *,a,b,xgt
      return
      end
