#!/bin/ksh
# output of postscript files to actual printers
#
if 
   [ $bemps  ]
then
   :
else
   bemps="bp34e"
fi
case $1
in
   p) printer=$bemps;;
   h) printer="bp34h";;
   f) echo "No printing, ps-file remains."
      exit;;
   *) echo printer-code unknown.
      exit 99;;
esac
shift
echo ps-output to printer $printer started at `date`
lpr -P$printer $@
rc=$?
lpq -P$printer
echo rc=$rc
[ rc -eq 0 ] || exit 12
